/* Generated by GOB (v2.0.15)   (do not edit directly) */

#include <glib.h>
#include <glib-object.h>
#ifndef __STUFFKEEPER_DATA_SCHEMA_H__
#define __STUFFKEEPER_DATA_SCHEMA_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtk.h>
#include <sqlite3.h>



    typedef enum _FieldType{
        FIELD_TYPE_STRING = 0,
        FIELD_TYPE_INTEGER = 1,
        FIELD_TYPE_BOOLEAN = 2,
        FIELD_TYPE_RATING = 3,
        FIELD_TYPE_LIST = 4,
        FIELD_TYPE_TEXT = 5,
        FIELD_TYPE_IMAGE = 6,
        FIELD_TYPE_LINK = 7,
        FIELD_TYPE_DATE = 8,
        FIELD_TYPE_EXPANDER = 9,
        FIELD_TYPE_END_EXPANDER = 10,
        FIELD_TYPE_VPACKING = 11,
        FIELD_TYPE_END= 12,
        FIELD_TYPE_HPACKING = 13,
        FIELD_TYPE_NUM_FIELDS
    } FieldType;
    extern char *FieldNames[FIELD_TYPE_NUM_FIELDS];



    typedef enum _DbSchemaType {
        DB_SCHEMAS_TYPE_ID = 1,
        DB_SCHEMAS_TYPE_MTIME = 2,
        DB_SCHEMAS_TYPE_CTIME = 3,
        DB_SCHEMAS_TYPE_ICON = 4,
        DB_SCHEMAS_TYPE_NAME = 5

    }DbSchemaType;
    typedef enum _DbSchemaFieldType {
        DB_SCHEMAS_FIELD_TYPE_ID = 1,
        DB_SCHEMAS_FIELD_TYPE_ORDER = 2,
        DB_SCHEMAS_FIELD_TYPE_TYPE = 3,
        DB_SCHEMAS_FIELD_TYPE_NAME = 4,
        DB_SCHEMAS_FIELD_TYPE_IN_TITLE = 5

    }DbSchemaFieldType;


/*
 * Type checking and casting macros
 */
#define STUFFKEEPER_TYPE_DATA_SCHEMA	(stuffkeeper_data_schema_get_type())
#define STUFFKEEPER_DATA_SCHEMA(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), stuffkeeper_data_schema_get_type(), StuffKeeperDataSchema)
#define STUFFKEEPER_DATA_SCHEMA_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), stuffkeeper_data_schema_get_type(), StuffKeeperDataSchema const)
#define STUFFKEEPER_DATA_SCHEMA_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), stuffkeeper_data_schema_get_type(), StuffKeeperDataSchemaClass)
#define STUFFKEEPER_IS_DATA_SCHEMA(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), stuffkeeper_data_schema_get_type ())

#define STUFFKEEPER_DATA_SCHEMA_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), stuffkeeper_data_schema_get_type(), StuffKeeperDataSchemaClass)

/* Private structure type */
typedef struct _StuffKeeperDataSchemaPrivate StuffKeeperDataSchemaPrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_STUFFKEEPER_DATA_SCHEMA__
#define __TYPEDEF_STUFFKEEPER_DATA_SCHEMA__
typedef struct _StuffKeeperDataSchema StuffKeeperDataSchema;
#endif
struct _StuffKeeperDataSchema {
	GObject __parent__;
	/*< private >*/
	StuffKeeperDataSchemaPrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _StuffKeeperDataSchemaClass StuffKeeperDataSchemaClass;
struct _StuffKeeperDataSchemaClass {
	GObjectClass __parent__;
	/*signal*/void (* schema_changed) (StuffKeeperDataSchema * self);
	/*signal*/void (* schema_field_changed) (StuffKeeperDataSchema * self, const gchar * field);
	/*signal*/void (* schema_field_added) (StuffKeeperDataSchema * self, const gchar * field);
	/*signal*/void (* schema_fields_reordered) (StuffKeeperDataSchema * self);
	/*signal*/void (* schema_field_removed) (StuffKeeperDataSchema * self, const gchar * field);
};


/*
 * Public methods
 */
GType	stuffkeeper_data_schema_get_type	(void);
StuffKeeperDataSchema * 	stuffkeeper_data_schema_open_from_id	(GObject * skdb,
					sqlite3 * sqlHandle,
					gint id);
StuffKeeperDataSchema * 	stuffkeeper_data_schema_new	(GObject * skdb,
					sqlite3 * sqlHandle);
StuffKeeperDataSchema * 	stuffkeeper_data_schema_new_with_id	(GObject * skdb,
					sqlite3 * sqlHandle,
					gint id);
void 	stuffkeeper_data_schema_save_yourself	(StuffKeeperDataSchema * self);
void 	stuffkeeper_data_schema_delete_yourself	(StuffKeeperDataSchema * self);
gint 	stuffkeeper_data_schema_get_id	(StuffKeeperDataSchema * self);
void 	stuffkeeper_data_schema_field_schemas_set_field_string	(StuffKeeperDataSchema * self,
					int fieldtype,
					const gchar * id,
					const gchar * title);
void 	stuffkeeper_data_schema_schemas_set_field	(StuffKeeperDataSchema * self,
					int fieldtype,
					const gchar * title);
void 	stuffkeeper_data_schema_set_title	(StuffKeeperDataSchema * self,
					const gchar * title);
gchar * 	stuffkeeper_data_schema_get_title	(StuffKeeperDataSchema * self);
gchar ** 	stuffkeeper_data_schema_get_fields	(StuffKeeperDataSchema * self,
					gsize * size);
int 	stuffkeeper_data_schema_get_field_pos	(StuffKeeperDataSchema * self,
					const gchar * id);
FieldType 	stuffkeeper_data_schema_get_field_type	(StuffKeeperDataSchema * self,
					const gchar * id);
void 	stuffkeeper_data_schema_set_field_type	(StuffKeeperDataSchema * self,
					const gchar * id,
					FieldType type);
gchar * 	stuffkeeper_data_schema_get_field_name	(StuffKeeperDataSchema * self,
					const gchar * id);
void 	stuffkeeper_data_schema_set_field_name	(StuffKeeperDataSchema * self,
					const gchar * id,
					const gchar * name);
int 	stuffkeeper_data_schema_has_generated_title	(StuffKeeperDataSchema * self);
void 	stuffkeeper_data_schema_set_field_in_title	(StuffKeeperDataSchema * self,
					const gchar * id,
					const int in_title);
int 	stuffkeeper_data_schema_get_field_in_title	(StuffKeeperDataSchema * self,
					const gchar * id);
void 	stuffkeeper_data_schema_add_field	(StuffKeeperDataSchema * self,
					FieldType field,
					const gchar * name,
					int in_title);
void 	stuffkeeper_data_schema_remove_field	(StuffKeeperDataSchema * self,
					const gchar * id);
int 	stuffkeeper_data_schema_num_items	(StuffKeeperDataSchema * self);
void 	stuffkeeper_data_schema_add_item	(StuffKeeperDataSchema * self,
					GObject * item);
void 	stuffkeeper_data_schema_remove_item	(StuffKeeperDataSchema * self,
					GObject * item);
void 	stuffkeeper_data_schema_set_icon	(StuffKeeperDataSchema * self,
					const gchar * filename);
GdkPixbuf * 	stuffkeeper_data_schema_get_pixbuf	(StuffKeeperDataSchema * self);
GList * 	stuffkeeper_data_schema_get_items	(StuffKeeperDataSchema * self);
StuffKeeperDataSchema * 	stuffkeeper_data_schema_load_from_xml	(GObject * skdb,
					sqlite3 * sqlHandle,
					const char * path);
gboolean 	stuffkeeper_data_schema_save_to_xml	(StuffKeeperDataSchema * self,
					const char * path);
GObject * 	stuffkeeper_data_schema_get_backend	(StuffKeeperDataSchema * self);
void 	stuffkeeper_data_schema_field_reorder	(StuffKeeperDataSchema * self,
					const char ** fields);

/*
 * Signal connection wrapper macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define stuffkeeper_data_schema_connect__schema_changed(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_SCHEMA(__extension__ ({StuffKeeperDataSchema *___object = (object); ___object; })),"schema_changed",(GCallback) __extension__ ({void (* ___schema_changed) (StuffKeeperDataSchema * ___fake___self, gpointer ___data ) = (func); ___schema_changed; }), (data))
#define stuffkeeper_data_schema_connect_after__schema_changed(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_SCHEMA(__extension__ ({StuffKeeperDataSchema *___object = (object); ___object; })),"schema_changed",(GCallback) __extension__ ({void (* ___schema_changed) (StuffKeeperDataSchema * ___fake___self, gpointer ___data ) = (func); ___schema_changed; }), (data))
#define stuffkeeper_data_schema_connect_data__schema_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_SCHEMA(__extension__ ({StuffKeeperDataSchema *___object = (object); ___object; })),"schema_changed",(GCallback) __extension__ ({void (* ___schema_changed) (StuffKeeperDataSchema * ___fake___self, gpointer ___data ) = (func); ___schema_changed; }), (data), (destroy_data), (GConnectFlags)(flags))
#define stuffkeeper_data_schema_connect__schema_field_changed(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_SCHEMA(__extension__ ({StuffKeeperDataSchema *___object = (object); ___object; })),"schema_field_changed",(GCallback) __extension__ ({void (* ___schema_field_changed) (StuffKeeperDataSchema * ___fake___self, const gchar * ___fake___field, gpointer ___data ) = (func); ___schema_field_changed; }), (data))
#define stuffkeeper_data_schema_connect_after__schema_field_changed(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_SCHEMA(__extension__ ({StuffKeeperDataSchema *___object = (object); ___object; })),"schema_field_changed",(GCallback) __extension__ ({void (* ___schema_field_changed) (StuffKeeperDataSchema * ___fake___self, const gchar * ___fake___field, gpointer ___data ) = (func); ___schema_field_changed; }), (data))
#define stuffkeeper_data_schema_connect_data__schema_field_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_SCHEMA(__extension__ ({StuffKeeperDataSchema *___object = (object); ___object; })),"schema_field_changed",(GCallback) __extension__ ({void (* ___schema_field_changed) (StuffKeeperDataSchema * ___fake___self, const gchar * ___fake___field, gpointer ___data ) = (func); ___schema_field_changed; }), (data), (destroy_data), (GConnectFlags)(flags))
#define stuffkeeper_data_schema_connect__schema_field_added(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_SCHEMA(__extension__ ({StuffKeeperDataSchema *___object = (object); ___object; })),"schema_field_added",(GCallback) __extension__ ({void (* ___schema_field_added) (StuffKeeperDataSchema * ___fake___self, const gchar * ___fake___field, gpointer ___data ) = (func); ___schema_field_added; }), (data))
#define stuffkeeper_data_schema_connect_after__schema_field_added(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_SCHEMA(__extension__ ({StuffKeeperDataSchema *___object = (object); ___object; })),"schema_field_added",(GCallback) __extension__ ({void (* ___schema_field_added) (StuffKeeperDataSchema * ___fake___self, const gchar * ___fake___field, gpointer ___data ) = (func); ___schema_field_added; }), (data))
#define stuffkeeper_data_schema_connect_data__schema_field_added(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_SCHEMA(__extension__ ({StuffKeeperDataSchema *___object = (object); ___object; })),"schema_field_added",(GCallback) __extension__ ({void (* ___schema_field_added) (StuffKeeperDataSchema * ___fake___self, const gchar * ___fake___field, gpointer ___data ) = (func); ___schema_field_added; }), (data), (destroy_data), (GConnectFlags)(flags))
#define stuffkeeper_data_schema_connect__schema_fields_reordered(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_SCHEMA(__extension__ ({StuffKeeperDataSchema *___object = (object); ___object; })),"schema_fields_reordered",(GCallback) __extension__ ({void (* ___schema_fields_reordered) (StuffKeeperDataSchema * ___fake___self, gpointer ___data ) = (func); ___schema_fields_reordered; }), (data))
#define stuffkeeper_data_schema_connect_after__schema_fields_reordered(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_SCHEMA(__extension__ ({StuffKeeperDataSchema *___object = (object); ___object; })),"schema_fields_reordered",(GCallback) __extension__ ({void (* ___schema_fields_reordered) (StuffKeeperDataSchema * ___fake___self, gpointer ___data ) = (func); ___schema_fields_reordered; }), (data))
#define stuffkeeper_data_schema_connect_data__schema_fields_reordered(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_SCHEMA(__extension__ ({StuffKeeperDataSchema *___object = (object); ___object; })),"schema_fields_reordered",(GCallback) __extension__ ({void (* ___schema_fields_reordered) (StuffKeeperDataSchema * ___fake___self, gpointer ___data ) = (func); ___schema_fields_reordered; }), (data), (destroy_data), (GConnectFlags)(flags))
#define stuffkeeper_data_schema_connect__schema_field_removed(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_SCHEMA(__extension__ ({StuffKeeperDataSchema *___object = (object); ___object; })),"schema_field_removed",(GCallback) __extension__ ({void (* ___schema_field_removed) (StuffKeeperDataSchema * ___fake___self, const gchar * ___fake___field, gpointer ___data ) = (func); ___schema_field_removed; }), (data))
#define stuffkeeper_data_schema_connect_after__schema_field_removed(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_SCHEMA(__extension__ ({StuffKeeperDataSchema *___object = (object); ___object; })),"schema_field_removed",(GCallback) __extension__ ({void (* ___schema_field_removed) (StuffKeeperDataSchema * ___fake___self, const gchar * ___fake___field, gpointer ___data ) = (func); ___schema_field_removed; }), (data))
#define stuffkeeper_data_schema_connect_data__schema_field_removed(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_SCHEMA(__extension__ ({StuffKeeperDataSchema *___object = (object); ___object; })),"schema_field_removed",(GCallback) __extension__ ({void (* ___schema_field_removed) (StuffKeeperDataSchema * ___fake___self, const gchar * ___fake___field, gpointer ___data ) = (func); ___schema_field_removed; }), (data), (destroy_data), (GConnectFlags)(flags))
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define stuffkeeper_data_schema_connect__schema_changed(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_SCHEMA(object),"schema_changed",(GCallback)(func),(data))
#define stuffkeeper_data_schema_connect_after__schema_changed(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_SCHEMA(object),"schema_changed",(GCallback)(func),(data))
#define stuffkeeper_data_schema_connect_data__schema_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_SCHEMA(object),"schema_changed",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define stuffkeeper_data_schema_connect__schema_field_changed(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_SCHEMA(object),"schema_field_changed",(GCallback)(func),(data))
#define stuffkeeper_data_schema_connect_after__schema_field_changed(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_SCHEMA(object),"schema_field_changed",(GCallback)(func),(data))
#define stuffkeeper_data_schema_connect_data__schema_field_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_SCHEMA(object),"schema_field_changed",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define stuffkeeper_data_schema_connect__schema_field_added(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_SCHEMA(object),"schema_field_added",(GCallback)(func),(data))
#define stuffkeeper_data_schema_connect_after__schema_field_added(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_SCHEMA(object),"schema_field_added",(GCallback)(func),(data))
#define stuffkeeper_data_schema_connect_data__schema_field_added(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_SCHEMA(object),"schema_field_added",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define stuffkeeper_data_schema_connect__schema_fields_reordered(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_SCHEMA(object),"schema_fields_reordered",(GCallback)(func),(data))
#define stuffkeeper_data_schema_connect_after__schema_fields_reordered(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_SCHEMA(object),"schema_fields_reordered",(GCallback)(func),(data))
#define stuffkeeper_data_schema_connect_data__schema_fields_reordered(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_SCHEMA(object),"schema_fields_reordered",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define stuffkeeper_data_schema_connect__schema_field_removed(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_SCHEMA(object),"schema_field_removed",(GCallback)(func),(data))
#define stuffkeeper_data_schema_connect_after__schema_field_removed(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_SCHEMA(object),"schema_field_removed",(GCallback)(func),(data))
#define stuffkeeper_data_schema_connect_data__schema_field_removed(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_SCHEMA(object),"schema_field_removed",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
